## visad
Interface Function

All Superinterfaces:
  Data, Thing

All Known Subinterfaces:
  Field, FlatFieldIface, ImageSequence, NavigatedField, RemoteClientField, RemoteClientPartitionedField, RemoteField, RemoteFlatField, RemoteFunction, RemoteNodeField, RemoteNodePartitionedField, SingleBandedImage

All Known Implementing Classes:
  FieldImpl, FlatField, FunctionImpl, ImageSequenceImpl, NavigatedImage, RemoteClientFieldImpl, RemoteClientPartitionedFieldImpl, RemoteFieldImpl, RemoteFlatFieldImpl, RemoteFunctionImpl, RemoteNodeFieldImpl, RemoteNodePartitionedFieldImpl, SingleBandedImageImpl

public interface Function
extends Data

Function is the interface for approximate implmentations of mathematical function.

Field Summary

Fields inherited from interface visad.Data

`ABS, ACOS, ACOS_DEGREES, ADD, ASIN, ASIN_DEGREES, ATAN, ATAN_DEGREES, ATAN2, ATAN2_DEGREES, CEIL, COS, COS_DEGREES, DEGREES_TO_RADIANS, DEPENDENT, DIVIDE, EXP, FLOOR, INDEPENDENT, INV_ATAN2, INV_ATAN2_DEGREES, INV_DIVIDE, INV_POW, INV_REMAINDER, INV_SUBTRACT, LOG, MAX, MIN, MULTIPLY, NEAREST_NEIGHBOR, NEGATE, NO_ERRORS, NOP, POW, RADIANS_TO_DEGREES, REMAINDER, RINT, ROUND, SIN, SIN_DEGREES, SQRT, SUBTRACT, TAN, TAN_DEGREES, WEIGHTED_AVERAGE`

Method Summary
`Data` `derivative(int error_mode)` return the tuple of derivatives of this Function with respect to all RealType components of its domain RealTuple; propogate errors according to error_mode
`Data` `derivative(MathType[] derivType_s, int error_mode)` return the tuple of derivatives of this Function with respect to all RealType components of its domain RealTuple; set result MathTypes of tuple components to derivType_s; propogate errors according to error_mode

`Data`

`derivative(RealTuple location, RealType[] d_partial_s, MathType[] derivType_s, int error_mode)`
return the tuple of derivatives of this Function with respect to the RealTypes in d_partial_s; the RealTypes in d_partial_s may occur in this Function's domain RealTupleType, or, if the domain has a CoordinateSystem, in its Reference RealTupleType; set result MathTypes of tuple components to derivType_s; propogate errors according to error_mode

`Function` `derivative(RealType d_partial, int error_mode)` return the derivative of this Function with respect to d_partial; d_partial may occur in this Function's domain RealTupleType, or, if the domain has a CoordinateSystem, in its Reference RealTupleType; propogate errors according to error_mode
`Function` `derivative(RealType d_partial, MathType derivType, int error_mode)` return the derivative of this Function with respect to d_partial; set result MathType to derivType; d_partial may occur in this Function's domain RealTupleType, or, if the domain has a CoordinateSystem, in its Reference RealTupleType; propogate errors according to error_mode
`Data` `evaluate(Real domain)` Evaluate this Function at domain; for 1-D domains use default modes for resampling (Data.WEIGHTED_AVERAGE) and errors (Data.NO_ERRORS)
`Data` `evaluate(Real domain, int sampling_mode, int error_mode)` Evaluate this Function, for 1-D domains, with non-default modes for resampling and errors
`Data` `evaluate(RealTuple domain)` Evaluate this Function at domain; use default modes for resampling (Data.WEIGHTED_AVERAGE) and errors (Data.NO_ERRORS)
`Data` `evaluate(RealTuple domain, int sampling_mode, int error_mode)` Evaluate this Function with non-default modes for resampling and errors
`CoordinateSystem` `getDomainCoordinateSystem()` Get the CoordinateSystem associated with the domain RealTuple
`int` `getDomainDimension()` Get the dimension (number of Real components) of this Function's domain
`Unit[]` `getDomainUnits()` Get the default Units of the Real components of the domain.
`Field` `resample(Set set)` Return a Field of Function values at the samples in set using default sampling_mode (WEIGHTED_AVERAGE) and error_mode (NO_ERRORS); This combines unit conversions, coordinate transforms, resampling and interpolation
`Field` `resample(Set set, int sampling_mode, int error_mode)` Resample range values of this Function to domain samples in set; return a Field (i.e., a finite sampling of a Function).

Methods inherited from interface visad.Data

`abs, abs, acos, acos, acosDegrees, acosDegrees, add, add, adjustSamplingError, asin, asin, asinDegrees, asinDegrees, atan, atan, atan2, atan2, atan2Degrees, atan2Degrees, atanDegrees, atanDegrees, binary, binary, ceil, ceil, changeMathType, computeRanges, computeRanges, computeRanges, cos, cos, cosDegrees, cosDegrees, dataClone, divide, divide, exp, exp, floor, floor, getType, isMissing, local, log, log, longString, longString, max, max, min, min, multiply, multiply, negate, negate, pow, pow, remainder, remainder, rint, rint, round, round, sin, sin, sinDegrees, sinDegrees, sqrt, sqrt, subtract, subtract, tan, tan, tanDegrees, tanDegrees, unary, unary`

Methods inherited from interface visad.Thing
`addReference, removeReference`

Method Detail

### getDomainDimension

    public int getDomainDimension()
                           throws VisADException,
                                  RemoteException

  Get the dimension (number of Real components) of this Function's domain

  Returns:
    number of RealType components (n in R^n space)
  Throws:
    `VisADException`
    `RemoteException`

### getDomainUnits

    public Unit[] getDomainUnits()
                          throws VisADException,
                                 RemoteException

  Get the default Units of the Real components of the domain.

  Returns:
    array of Unit-s in the same order as the RealTypes in the domain.
  Throws:
    `VisADException`
    `RemoteException`

### getDomainCoordinateSystem

    public CoordinateSystem getDomainCoordinateSystem()
                                               throws VisADException,
                                                      RemoteException

  Get the CoordinateSystem associated with the domain RealTuple

  Returns:
    CoordinateSystem of the domain
  Throws:
    `VisADException`
    `RemoteException`

### evaluate

    public Data evaluate(Real domain)
                  throws VisADException,
                         RemoteException

  Evaluate this Function at domain; for 1-D domains use default modes for resampling (Data.WEIGHTED_AVERAGE) and errors (Data.NO_ERRORS)

  Parameters:
    `domain` - value to evaluate at.
  Returns:
    Data object corresponding to the function value at that domain. may return a missing data object of the same type as the Function's range.
  Throws:
    `VisADException` - unable to evaluate function
    `RemoteException` - Java RMI exception

### evaluate

    public Data evaluate(Real domain,
                         int sampling_mode,
                         int error_mode)
                  throws VisADException,
                         RemoteException

  Evaluate this Function, for 1-D domains, with non-default modes for resampling and errors

  Parameters:
    `domain` - value to evaluate at.
    `sampling_mode` - type of interpolation to perform (e.g., Data.WEIGHTED_AVERAGE, Data.NEAREST_NEIGHBOR)
    `error_mode` - type of error estimation to perform (e.g., Data.INDEPENDENT, Data.DEPENDENT, Data.NO_ERRORS)
  Returns:
    Data object corresponding to the function value at that domain, using the sampling_mode and error_modes specified. May return a missing data object of the same type as the Function's range.
  Throws:
    `VisADException` - unable to evaluate function
    `RemoteException` - Java RMI exception

### evaluate

    public Data evaluate(RealTuple domain)
                  throws VisADException,
                         RemoteException

  Evaluate this Function at domain; use default modes for resampling (Data.WEIGHTED_AVERAGE) and errors (Data.NO_ERRORS)

  Parameters:
    `domain` - value to evaluate at.
  Returns:
    Data object corresponding to the function value at that domain. may return a missing data object of the same type as the Function's range.
  Throws:
    `VisADException` - unable to evaluate function
    `RemoteException` - Java RMI exception

### evaluate

    public Data evaluate(RealTuple domain,
                         int sampling_mode,
                         int error_mode)
                  throws VisADException,
                         RemoteException

  Evaluate this Function with non-default modes for resampling and errors

  Parameters:
    `domain` - value to evaluate at.
    `sampling_mode` - type of interpolation to perform (e.g., Data.WEIGHTED_AVERAGE, Data.NEAREST_NEIGHBOR)
    `error_mode` - type of error estimation to perform (e.g., Data.INDEPENDENT, Data.DEPENDENT, Data.NO_ERRORS)
  Returns:
    Data object corresponding to the function value at that domain, using the sampling_mode and error_modes specified. May return a missing data object of the same type as the Function's range.
  Throws:
    `VisADException` - unable to evaluate function
    `RemoteException` - Java RMI exception

### resample

    public Field resample(Set set)
                   throws VisADException,
                          RemoteException

  Return a Field of Function values at the samples in set using default sampling_mode (WEIGHTED_AVERAGE) and error_mode (NO_ERRORS); This combines unit conversions, coordinate transforms, resampling and interpolation

  Parameters:
    `set` - finite sampling values for the function.
  Returns:
    Data object corresponding to the function value at that domain. may return a missing data object of the same type as the Function's range.
  Throws:
    `VisADException` - unable to resample function
    `RemoteException` - Java RMI exception

### resample

    public Field resample(Set set,
                          int sampling_mode,
                          int error_mode)
                   throws VisADException,
                          RemoteException

  Resample range values of this Function to domain samples in set; return a Field (i.e., a finite sampling of a Function). Use the specified sampling_mode and error_mode. This combines unit conversions, coordinate transforms, resampling and interpolation

  Parameters:
    `set` - finite sampling values for the function.
    `sampling_mode` - type of interpolation to perform (e.g., Data.WEIGHTED_AVERAGE, Data.NEAREST_NEIGHBOR)
    `error_mode` - type of error estimation to perform (e.g., Data.INDEPENDENT, Data.DEPENDENT, Data.NO_ERRORS)
  Returns:
    Data object corresponding to the function value at that domain, using the sampling_mode and error_modes specified. May return a missing data object of the same type as the Function's range.
  Throws:
    `VisADException` - unable to resample function
    `RemoteException` - Java RMI exception

### derivative

    public Function derivative(RealType d_partial,
                               int error_mode)
                        throws VisADException,
                               RemoteException

  return the derivative of this Function with respect to d_partial; d_partial may occur in this Function's domain RealTupleType, or, if the domain has a CoordinateSystem, in its Reference RealTupleType; propogate errors according to error_mode

  Throws:
    `VisADException`
    `RemoteException`

### derivative

    public Function derivative(RealType d_partial,
                               MathType derivType,
                               int error_mode)
                        throws VisADException,
                               RemoteException

  return the derivative of this Function with respect to d_partial; set result MathType to derivType; d_partial may occur in this Function's domain RealTupleType, or, if the domain has a CoordinateSystem, in its Reference RealTupleType; propogate errors according to error_mode

  Throws:
    `VisADException`
    `RemoteException`

### derivative

    public Data derivative(int error_mode)
                    throws VisADException,
                           RemoteException

  return the tuple of derivatives of this Function with respect to all RealType components of its domain RealTuple; propogate errors according to error_mode

  Throws:
    `VisADException`
    `RemoteException`

### derivative

    public Data derivative(MathType[] derivType_s,
                           int error_mode)
                    throws VisADException,
                           RemoteException

  return the tuple of derivatives of this Function with respect to all RealType components of its domain RealTuple; set result MathTypes of tuple components to derivType_s; propogate errors according to error_mode

  Throws:
    `VisADException`
    `RemoteException`

### derivative

    public Data derivative(RealTuple location,
                           RealType[] d_partial_s,
                           MathType[] derivType_s,
                           int error_mode)
                    throws VisADException,
                           RemoteException

  return the tuple of derivatives of this Function with respect to the RealTypes in d_partial_s; the RealTypes in d_partial_s may occur in this Function's domain RealTupleType, or, if the domain has a CoordinateSystem, in its Reference RealTupleType; set result MathTypes of tuple components to derivType_s; propogate errors according to error_mode

  Throws:
    `VisADException`
    `RemoteException`